summaryrefslogtreecommitdiffhomepage
path: root/test
diff options
context:
space:
mode:
authorYukihiro "Matz" Matsumoto <[email protected]>2012-05-14 06:15:42 -0700
committerYukihiro "Matz" Matsumoto <[email protected]>2012-05-14 06:15:42 -0700
commitbcb743fccba0628362e284515edade211dd55e19 (patch)
treea29397364f5c6f05b2f1bdd24af5f13a6472a6f7 /test
parent6b67801d4e643583746da41a74218145236b8f9d (diff)
parentc82a518ee1df250a03abb82aa58a1bfd2c04cfc3 (diff)
downloadmruby-bcb743fccba0628362e284515edade211dd55e19.tar.gz
mruby-bcb743fccba0628362e284515edade211dd55e19.zip
Merge pull request #131 from bovi/master
mrit - Embeddable Ruby ISO Test
Diffstat (limited to 'test')
-rw-r--r--test/Makefile70
-rw-r--r--test/_assert.rb44
-rw-r--r--test/array.rb40
-rw-r--r--test/init_mritlib.c17
-rw-r--r--test/test_time.rb48
-rw-r--r--test/time.rb73
6 files changed, 244 insertions, 48 deletions
diff --git a/test/Makefile b/test/Makefile
new file mode 100644
index 000000000..b7a6572c8
--- /dev/null
+++ b/test/Makefile
@@ -0,0 +1,70 @@
+# makefile discription.
+# basic build file for mruby library (Ruby part)
+
+# project-specific macros
+# extension of the executable-file is modifiable(.exe .out ...)
+BASEDIR = .
+TARGET := mritlib
+MLIB := $(TARGET).o
+CLIB := $(TARGET).c
+DLIB := $(TARGET).ctmp
+RLIB := $(TARGET).rbtmp
+DEPLIB := $(TARGET).d
+MRB1 := $(BASEDIR)/*.rb
+MRBS := $(MRB1)
+LIBR := ../lib/libmrit.a
+
+# C compiler (gcc)
+CC = gcc
+LL = gcc
+AR = ar
+DEBUG_MODE = 1
+ifeq ($(DEBUG_MODE),1)
+CFLAGS = -g
+else
+CFLAGS = -O3
+endif
+INCLUDES = -I../src -I../include
+ALL_CFLAGS = -Wall -Werror-implicit-function-declaration $(CFLAGS)
+ifeq ($(OS),Windows_NT)
+ MAKE_FLAGS = CC=$(CC) LL=$(LL) ALL_CFLAGS="$(ALL_CFLAGS)"
+else
+ MAKE_FLAGS = CC='$(CC)' LL='$(LL)' ALL_CFLAGS='$(ALL_CFLAGS)'
+endif
+
+# mruby compiler
+ifeq ($(OS),Windows_NT)
+MRBC = ../bin/mrbc.exe
+else
+MRBC = ../bin/mrbc
+endif
+
+##############################
+# generic build targets, rules
+
+.PHONY : all
+all : $(MRBC) $(MLIB)
+ $(AR) r $(LIBR) $(MLIB)
+ @echo "make: built targets of `pwd`"
+
+# Compile mrblib source
+$(MLIB) : $(CLIB)
+ $(CC) $(ALL_CFLAGS) -MMD $(INCLUDES) -c $(CLIB) -o $(MLIB)
+
+# Compile C source from merged mruby source
+$(CLIB) : $(RLIB) $(MRBC)
+ $(MRBC) -Bmritlib_irep -o$(DLIB) $(RLIB); cat init_$(TARGET).c $(DLIB) > $@
+
+$(MRBC) : ../src/opcode.h ../src/codegen.c ../src/parse.y
+ $(MAKE) -C ../tools/mrbc $(MAKE_FLAGS)
+
+# merge mruby sources
+$(RLIB) : $(MRBS)
+ cat $? > $@
+
+# clean up
+.PHONY : clean
+clean :
+ @echo "make: removing targets, objects and depend files of `pwd`"
+ -rm -f $(MRBC) $(MLIB) $(CLIB) $(RLIB) $(DLIB) $(DEPLIB) $(LIBR)
+
diff --git a/test/_assert.rb b/test/_assert.rb
new file mode 100644
index 000000000..91751f769
--- /dev/null
+++ b/test/_assert.rb
@@ -0,0 +1,44 @@
+$ok_test = 0
+$ko_test = 0
+$asserts = []
+
+##
+# Verify a code block.
+#
+# str : A remark which will be printed in case
+# this assertion fails
+# iso : The ISO reference code of the feature
+# which will be tested by this
+# assertion
+def assert(str = 'Assertion failed', iso = '')
+ if(!yield)
+ $asserts.push([str, iso])
+ $ko_test += 1
+ print "F"
+ else
+ $ok_test += 1
+ print "."
+ end
+end
+
+##
+# Report the test result and print all assertions
+# which were reported broken.
+def report()
+ print "\n"
+ $asserts.each do |str, iso|
+ print("Test Failed: #{str} [#{iso}]\n");
+ end
+
+ $total_test = $ok_test + $ko_test
+ print 'Total tests:'
+ print $total_test
+ print "\n"
+
+ print ' OK: '
+ print $ok_test
+ print "\n"
+ print ' KO: '
+ print $ko_test
+ print "\n"
+end
diff --git a/test/array.rb b/test/array.rb
new file mode 100644
index 000000000..3b65a80dd
--- /dev/null
+++ b/test/array.rb
@@ -0,0 +1,40 @@
+##
+# Array ISO Test
+
+assert('Array', '15.2.12') do
+ Array.class == Class
+end
+
+assert('Array.[]', '15.2.12.4.1') do
+ Array.[](1,2,3) == [1, 2, 3]
+end
+
+assert('Array#*', '15.2.12.5.1') do
+ [1].*(3) == [1, 1, 1]
+end
+
+assert('Array#+', '15.2.12.5.2') do
+ [1].+([1]) == [1, 1]
+end
+
+assert('Array#<<', '15.2.12.5.3') do
+ [1].<<(1) == [1, 1]
+end
+
+assert('Array#[]', '15.2.12.5.4') do
+ [1,2,3].[](1) == 2
+end
+
+assert('Array#[]=', '15.2.12.5.5') do
+ [1,2,3].[]=(1,4) == [1, 4, 3]
+end
+
+assert('Array#clear', '15.2.12.5.6') do
+ a = [1]
+ a.clear
+ a == []
+end
+
+# Not ISO specified
+
+
diff --git a/test/init_mritlib.c b/test/init_mritlib.c
new file mode 100644
index 000000000..73b926b87
--- /dev/null
+++ b/test/init_mritlib.c
@@ -0,0 +1,17 @@
+#include "mruby.h"
+#include "mruby/irep.h"
+#include "mruby/dump.h"
+#include "mruby/string.h"
+#include "mruby/proc.h"
+
+extern const char mritlib_irep[];
+
+void
+mrb_init_mritlib(mrb_state *mrb)
+{
+ int n = mrb_read_irep(mrb, mritlib_irep);
+
+ extern mrb_value mrb_top_self(mrb_state *mrb);
+ mrb_run(mrb, mrb_proc_new(mrb, mrb->irep[n]), mrb_top_self(mrb));
+}
+
diff --git a/test/test_time.rb b/test/test_time.rb
deleted file mode 100644
index ea6e98696..000000000
--- a/test/test_time.rb
+++ /dev/null
@@ -1,48 +0,0 @@
-$ok = 0
-$failed = 0
-$ftest = []
-
-def assert(str = "Assertion failed")
- if(!yield)
- $ftest.push(str)
- $failed += 1
- print "F"
- else
- $ok += 1
- print "."
- end
-end
-
-def report()
- print "\n"
- $ftest.each do |str|
- puts("Test Failed: #{str}");
- end
- $total = $ok + $failed
- puts "Ran #{$total} tests: #{$ok} OK and #{$failed} failed."
-end
-
-doom = Time.gm(2012, 12, 23)
-assert("Time.gm") { doom }
-assert("gm year") { doom.year == 2012 }
-assert("gm month") { doom.month == 12 }
-assert("gm day") { doom.mday == 23 }
-
-t0 = Time.new
-assert("Can create time.") { t0 }
-
-t1 = Time.at(1300000000.0).utc
-assert("asctime") { t1.asctime == "Sun Mar 13 07:06:40 UTC 2011" }
-assert("usec") { t1.usec == 0 }
-assert("to_i") { t1.to_i == 1300000000 }
-assert("to_f") { t1.to_f == 1300000000.0 }
-assert("utc?") { t1.utc? }
-assert("zone") { t1.zone == "UTC" }
-assert("wday") { t1.wday == 0 }
-assert("yday") { t1.yday == 71 }
-assert("year") { t1.year == 2011 }
-
-t2 = Time.at(7.0e6)
-assert("initialize_copy") { t2.clone == t2 }
-
-report()
diff --git a/test/time.rb b/test/time.rb
new file mode 100644
index 000000000..f33cdde0d
--- /dev/null
+++ b/test/time.rb
@@ -0,0 +1,73 @@
+##
+# Time ISO Test
+
+assert('Time', '15.2.19') do
+ Time.class == Class
+end
+
+assert('Time.at', '15.2.19.6.1') do
+ Time.at(1300000000.0)
+end
+
+assert('Time.gm', '15.2.19.6.2') do
+ Time.gm(2012, 12, 23)
+end
+
+assert('Time#asctime', '15.2.19.7.4') do
+ Time.at(1300000000.0).utc.asctime == "Sun Mar 13 07:06:40 UTC 2011"
+end
+
+assert('Time#initialize_copy', '15.2.19.7.17') do
+ time_tmp_2 = Time.at(7.0e6)
+ time_tmp_2.clone == time_tmp_2
+end
+
+assert('Time#mday', '15.2.19.7.19') do
+ Time.gm(2012, 12, 23).mday == 23
+end
+
+assert('Time#month', '15.2.19.7.22') do
+ Time.gm(2012, 12, 23).month == 12
+end
+
+assert('Time#to_f', '15.2.19.7.24') do
+ Time.at(1300000000.0).to_f == 1300000000.0
+end
+
+assert('Time#to_i', '15.2.19.7.25') do
+ Time.at(1300000000.0).to_i == 1300000000
+end
+
+assert('Time#usec', '15.2.19.7.26') do
+ Time.at(1300000000.0).usec == 0
+end
+
+assert('Time#utc', '15.2.19.7.27') do
+ Time.at(1300000000.0).utc
+end
+
+assert('Time#utc?', '15.2.19.7.28') do
+ Time.at(1300000000.0).utc.utc?
+end
+
+assert('Time#wday', '15.2.19.7.30') do
+ Time.at(1300000000.0).utc.wday == 0
+end
+
+assert('Time#yday', '15.2.19.7.31') do
+ Time.at(1300000000.0).utc.yday == 71
+end
+
+assert('Time#year', '15.2.19.7.32') do
+ Time.gm(2012, 12, 23).year == 2012
+end
+
+assert('Time#zone', '15.2.19.7.33') do
+ Time.at(1300000000.0).utc.zone == 'UTC'
+end
+
+# Not ISO specified
+
+assert('Time#new') do
+ Time.new.class == Time
+end